;
;   GIF Include and Show Mini Sample by Pavlushin Evgeni for ASCL
;   Load bmp image from hd and show with macros
;   www.waptap@mail.ru
;


;******************************************************************************
    use32
    org    0x0
    db     'MENUET01'              ; 8 byte id
    dd     0x01                    ; header version
    dd     START                   ; start of code
    dd     IM_END                  ; size of image
    dd     I_END                   ; memory for app
    dd     I_END                   ; esp
    dd     0x0 , 0x0               ; I_Param , I_Icon

;******************************************************************************


include 'ascl.inc'
include 'ascgl.inc'


macro readmas masoff,obroff
{
local loo
    mov edi,masoff   ;tekoff
    add edi,8
    mov ebp,[masoff]   ;elements
    mov edx,[masoff+4] ;elemsize
    mov eax,0 ;count
loo:
    pushad
    call obroff
    popad
    add  edi,edx
    inc  eax
    cmp  eax,ebp
    jne  loo
}


macro compmas masoff1,masoff2,obroff
{
local loo,loo2
    mov esi,masoff2
    add esi,8
    mov ecx,[masoff2]
    mov ebx,[masoff2+4]
    mov eax,0

loo2:
    push eax

    mov edi,masoff1   ;tekoff
    add edi,8
    mov ebp,[masoff1]   ;elements1
    mov edx,[masoff1+4] ;elemsize1
    mov eax,0 ;count
loo:
    pushad
    call obroff
    popad
    add  edi,edx
    inc  eax
    cmp  eax,ebp
    jne  loo

    add  esi,ebx
    pop  eax
    inc  eax
    cmp  eax,ecx
    jne  loo2
}


macro findmas masoff,obroff
{
local loo,looend,lend
    mov edi,masoff   ;tekoff
    add edi,8
    mov ebp,[masoff]   ;elements
    mov edx,[masoff+4] ;elemsize
    mov eax,0 ;count
loo:
    pushad
    mov  eax,0
    call obroff
    cmp  eax,1
    je   looend
    popad
    add  edi,edx
    inc  eax
    cmp  eax,ebp
    jne  loo
    stc
    jmp  lend
looend:
    popad
    clc
lend:
}


randmas:
    push edi
    random 200,eax
    pop edi
    mov [edi],eax
    push edi
    random 200,eax
    pop edi
    mov [edi+4],eax
;    push edi
;    random 2,eax
;    pop edi
;    mov [edi+8],eax
    ret

randobjmas:
    push edi
    random 600,eax
    pop edi
    mov [edi],eax
    push edi
    random 40000,eax
    neg eax
    pop edi
    mov [edi+4],eax
    push edi
    random 3,eax
    inc eax
    pop edi
    mov [edi+8],eax
    ret


showmas:
    cmp [edi+8],dword 0
    je  noshow
;    setimg [edi],[edi+4],shoot
    cmp [edi+8],dword 1
    jne no_gun
    mov eax,shoot
    jmp outp
no_gun:
    mov eax,star
outp:
    aimgtoimg eax,dword [edi],dword [edi+4],canvas,0x0
noshow:
    ret

showobjmas:
    cmp [edi+8],dword 0
    je  noshow1
    cmp [edi+4],dword 380
    jg  noshow1
    cmp [edi+4],dword 0
    jl  noshow1
;    setimg [edi],[edi+4],shoot
    cmp [edi+8],dword 1
    jne no_warship1
    mov eax,warship1
    jmp outws
no_warship1:
    cmp [edi+8],dword 2
    jne no_warship2
    mov eax,warship2
    jmp outws
no_warship2:
    mov eax,meteor
outws:
    aimgtoimg eax,dword [edi],dword [edi+4],canvas,0x0
noshow1:
    ret


moveobjmas:
    cmp [edi+8],dword 0
    je  no_ws
    add dword [edi+4],5
no_ws:
    ret


delfarshoot:
    cmp [edi+4],dword 20
    ja  nodel
    mov [edi+8],dword 0
nodel:
    ret


movemas:
    cmp [edi+8],dword 1
    jne no_gunp
    cmp [edi+8],dword 0
    je  no_starp
    sub dword [edi+4],10
no_starp:
    ret
no_gunp:
    sub dword [edi+4],5
    mov eax,[edi+12]
    add [edi],eax
    mov eax,[edi+16]
    add [edi+4],eax
    ret
findzero:
    cmp [edi+8],dword 0
    je  iz_zero
    xor eax,eax
    ret
iz_zero:
    mov eax,1
    ret

compobr:
    cmp [esi+8],dword 0
    je  no_crsh
    cmp [edi+8],dword 0
    je  no_crsh

    mov eax,[esi]
    mov [temp],eax
    mov eax,[esi+4]
    mov [temp2],eax
    mov eax,[edi]
    mov [temp3],eax
    mov eax,[edi+4]
    mov [temp4],eax

    pushad
    collimg imgsize,[temp],[temp2],imgsize,[temp3],[temp4],[otv]
    popad
    cmp [otv],dword 0
    je  no_crsh
    mov [esi+8],dword 0
    mov [edi+8],dword 0
no_crsh:
    ret


START:                          ; start of execution

massize = 400
elemsize = 20

    mov [massive],dword massize
    mov [massive+4],dword elemsize

omassize = 40
oelemsize = 20

    mov [objmas],dword omassize
    mov [objmas+4],dword oelemsize


    mov eax,66
    mov ebx,1
    mov ecx,1
    int 0x40

    mov eax,26
    mov ebx,2
    mov ecx,1
    mov edx,keymap
    int 0x40

    mov [canvas],dword 640
    mov [canvas+4],dword 440

    readmas massive,randmas

;random warships
    readmas objmas,randobjmas


;step1 define offset of hash area for unpacking gif file
;      size 16384+4 bytes
    gif_hash_offset = gif_hash_area
;step2 converting gif format to img format for easy out to screen
;      gif_file_area - offset of gif load file
;      img_area      - offset of img image
    giftoimg gif_file_area,img_area
;step3 out image from img_area
    getimg img_area,0,0,32,32,ship
    getimg img_area,32,0,32,32,shoot
    getimg img_area,64,0,32,32,warship1
    getimg img_area,96,0,32,32,warship2
    getimg img_area,128,0,32,32,meteor
    getimg img_area,160,0,32,32,star


    call draw_window

;Main loop wait for event with 10msec
still:
    scevent red,key,button
no_event:
    delay 1

    cmp [ctime],dword 0
    je  no_dct
    dec dword [ctime]
no_dct:

    cmp [xtime],dword 0
    je  no_dxt
    dec dword [xtime]
no_dxt:

;    inc dword [pathtime]

    cmp [num5],dword 0
    je  no_addsh
    cmp [ctime],dword 0
    jne no_addsh
    findmas massive,findzero
;in edi off to free element
    jc  close_app
    mov eax,[shipx]
    mov [edi],eax
    mov eax,[shipy]
    mov [edi+4],eax
    mov [edi+8],dword 1   ;show
    mov [ctime],dword 16  ;wait for cannon
no_addsh:

    cmp [numplus],dword 0
    je  no_addplx
    cmp [xtime],dword 256-16
    jae no_addplx
    findmas massive,findzero
;in edi off to free element
    jc  close_app
    mov eax,[shipx]
    mov [edi],eax
    mov eax,[shipy]
    mov [edi+4],eax
    mov [edi+8],dword 2   ;show
    add [xtime],dword 8  ;wait for cannon
    cmp [xtime],dword 256
    jna okx
    mov [xtime],256
okx:
    mov [edi+12],dword 0  ;wait for cannon
    mov [edi+16],dword -8  ;wait for cannon
no_addplx:



    cmp [num2],dword 0
    je  no_addsh2
    cmp [xtime],dword 0
    jne no_addsh2

    mov eax,[shipy]
    mov [temp3],eax
    mov [temp2],dword 5
loox2:
    mov [temp],dword 10
loox:
    findmas massive,findzero
;in edi off to free element
    jc  close_app
    random 25,eax
    mov ebp,eax
    sub eax,12
    add eax,[shipx]
    mov [edi],eax
    shr ebp,3
    random ebp,eax
    neg eax
    add eax,[temp3] ;[shipy]
    mov [edi+4],eax
    mov [edi+8],dword 2   ;show hstar
    random 5,eax
    sub eax,2
    mov [edi+12],eax   ;show hstar
    random 7,eax
    sub eax,3
    mov [edi+16],eax   ;show hstar
    dec [temp]
    jnz loox
    sub [temp3],30
    dec [temp2]
    jnz loox2
    mov [xtime],dword 256  ;wait for cannon
no_addsh2:


    cmp [num1],dword 0
    je  no_left
    sub dword [shipx],5
no_left:

    cmp [num3],dword 0
    je  no_right
    add dword [shipx],5
no_right:

;clear scrbuf
    mov edi,canvas+8
    cld
    mov ecx,640*440*3/4
    mov eax,0
    rep stosd

    compmas objmas,massive,compobr

    readmas objmas,showobjmas
    readmas objmas,moveobjmas

    readmas massive,showmas
    readmas massive,movemas
    readmas massive,delfarshoot
    findmas massive,findzero
;in edi off to free element
    jc  close_app
;    mov [edi+8],dword 2
;no_write:

;    setimg [shipx],[shipy],ship
    aimgtoimg ship,[shipx],[shipy],canvas,0x0

    setimg 5,21,canvas

    drawfbox 150,5,64,5,0x000000
    mov eax,[xtime]
    sub eax,256
    neg eax
    shr eax,2
    drawfbox 150,5,eax,5,0x0000ff

    drawfbox 150,12,64,5,0x000000
    mov eax,[ctime]
    sub eax,16
    neg eax
    shl eax,2
    drawfbox 150,12,eax,5,0xffff00

;    drawfbox 220,12,64,5,0x000000
;    mov eax,[pathtime]
;    shr eax,7
;    drawfbox 220,12,eax,5,0xffff00

    jmp  still

  red:
    call draw_window
    jmp still

  key:                          ; key
    mov  eax,2
    int  0x40                   ; read (eax=2)

    shr eax,8
    and eax,0xff
    mov ah,al

    cmp ah,76
    jne no_num5d
    mov [num5],1
    jmp still
no_num5d:
    cmp ah,204
    jne no_num5u
    mov [num5],0
    jmp still
no_num5u:

    cmp ah,80
    jne no_num2d
    mov [num2],1
    jmp still
no_num2d:
    cmp ah,208
    jne no_num2u
    mov [num2],0
    jmp still
no_num2u:

    cmp ah,79 ;key_Space 85 exit
    jne no_num1d
    mov [num1],1
    jmp still
no_num1d:
    cmp ah,207 ;key_Space 85 exit
    jne no_num1u
    mov [num1],0
    jmp still
no_num1u:

    cmp ah,81 ;key_Space 85 exit
    jne no_num3d
    mov [num3],1
    jmp still
no_num3d:
    cmp ah,209 ;key_Space 85 exit
    jne no_num3u
    mov [num3],0
    jmp still
no_num3u:

    cmp ah,78  ;key_Space 85 exit
    jne no_numpd
    mov [numplus],1
    jmp still
no_numpd:
    cmp ah,206 ;key_Space 85 exit
    jne no_numpu
    mov [numplus],0
    jmp still
no_numpu:

    jmp  still                  ; not testing

  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40
    cmp  ah,1                   ; button id=1 ?
    jne  noclose
close_app:
    mov  eax,-1                 ; close this program
    int  0x40
  noclose:
    jmp  still

draw_window:
    startwd
    window 40,40,(640+9),(440+26),window_Skinned+0x00ffffff
    label  8,8,'ASCL DYNAMIC GAME',cl_White+font_Big
;    setimg 5,22,img_area
    endwd
    ret

; DATA AREA
IM_END:
;massive
shipx dd 300
shipy dd 400


;keys
num1 dd 0
num5 dd 0
num3 dd 0
num2 dd 0
numplus dd 0

;delay for cannon
ctime dd 0
;delay for nuke gun
xtime dd 0
;path time
;pathtime dd 0
;
temp  dd 0
temp2 dd 0
temp3 dd 0
temp4 dd 0
otv dd 0

;for collimg
imgsize:
 dd 32
 dd 32

;massive:
;dd 400  ;elements num
;dd 20  ;size of element in bytes
;rb 400*20


keymap:
rb 1000

;gif_file_area ~21500
gif_file_area:
file 'star.gif';include gif file
rb 50          ;50 bytes temp back zone
img_area:
rb 256*32*3+8
ship:
rb 32*32*3+8
shoot:
rb 32*32*3+8
warship1:
rb 32*32*3+8
warship2:
rb 32*32*3+8
meteor:
rb 32*32*3+8
star:
rb 32*32*3+8
gif_hash_area:
rd 4096+1      ;hash area size for unpacking GIF

massive:
rd massize  ;elements num
rd elemsize  ;size of element in bytes
rb massize*elemsize

objmas:
rd omassize  ;elements num
rd oelemsize  ;size of element in bytes
rb omassize*oelemsize


canvas:
canvas_x:
 rd 1
canvas_y:
 rd 1
rb (640*440*3)
I_END:
