;******************************************************
;***GRAPHICS EDIT ANIMAGE creted by andrew_programmer**
;******************************************************

use32
org 0x0

  db  'MENUET01'
  dd  0x1
  dd  START
  dd  I_END
  dd  0x19000;100 kb
  dd  0x19000;
  dd  0x0
  dd  0x0
  include 'giflib.inc'
  include 'bmplib.inc'
  include 'dialog.INC'
  include 'dialog2.inc'
  include 'design.inc'
  include 'graphlib.asm'
START:

;--------------------------------------------------------
;---------------set events mask--------------------------
;--------------------------------------------------------
   mov eax,40
   mov ebx,1100111b
   int 0x40

;---------------------------------------------------------
;--------initializate data and params of program----------
;---------------------------------------------------------
   mov [Scroll1CoordinatX],8+1
   mov [Scroll2CoordinatY],20+15+1+46+3
   mov [Window_SizeX],585
   mov [Window_SizeY],320
   mov [Window_CordinatX],50
   mov [Window_CordinatY],50
   mov [WorkScreen_SizeX],100
   mov [WorkScreen_SizeY],100
   mov [MaxWorkScreen_SizeX],100
   mov [MaxWorkScreen_SizeY],100
   mov [ScreenPointer],0x19000
   mov [PosX],0
   mov [PosY],0
   mov [Picture_SizeX],1
   mov [Picture_SizeY],1
   mov [k],1
   mov [PointerToPicture],0x19000+(1200*1000*3)+30*(20*20*3)+100000
   mov [PointerToCopyPicture],0x19000+(1200*1000*3)+30*(20*20*3)+100000
   mov [PointerToPalette],0x19000+(1200*100*3)+30*(20*20*3)+1
   mov [ReserveArray],0x19000+(1200*1000)*3+30*(20*20*3)+8
   and [save_flag],0

   finit
;----------------------------------------------------------
;--------get memory and draw window of program-------------
;----------------------------------------------------------
   and [extended_memory],0
   call GetMemory

   call load_icons
   call drawwin

;----------------------------------------------------------
;---------------------MAIN LOOP----------------------------
;----------------------------------------------------------
main_loop:
   still:

   call event

   cmp eax,1
   jne no_redraw_window
   call drawwin
   call drawwin
   jmp still
   no_redraw_window:
   cmp eax,3
   je buttons
   cmp eax,6
   je mouse
   cmp eax,2
   je keys
   jmp main_loop

;------------------------------------------
;-------------KEYS-------------------------
;------------------------------------------
   keys:

   mov eax,2
   int 0x40
   shr eax,8

   cmp eax,176
   jne key2
   sub [PosX],20
   jmp change_screen
 key2:
   cmp eax,179
   jne key3
   add [PosX],20
   jmp change_screen
 key3:
   cmp eax,177
   jne key4
   add [PosY],20
   jmp change_screen
 key4:
  cmp eax,178
   jne key5
   sub [PosY],20
   jmp change_screen
 key5:
   cmp eax,49
   jne key6
   mov [k],1
   mov [Scroll1CoordinatX],9
   mov [Scroll2CoordinatY],85
   call drawwin
   jmp change_screen
 key6:
   cmp eax,50
   jne key7
   mov [k],2
   mov [Scroll1CoordinatX],9
   mov [Scroll2CoordinatY],85
   call drawwin
   jmp change_screen
 key7:
   cmp eax,52
   jne key8
   mov [k],4
   mov [Scroll1CoordinatX],9
   mov [Scroll2CoordinatY],85
   call drawwin
   jmp change_screen
 key8:
   cmp eax,56
   jne key9
   mov [k],8
   mov [Scroll1CoordinatX],9
   mov [Scroll2CoordinatY],85
   call drawwin
   jmp change_screen
 key9:
   cmp eax,48
   jne key10
   mov [k],16
   mov [Scroll1CoordinatX],9
   mov [Scroll2CoordinatY],85
   call drawwin
   jmp change_screen
 key10:
   cmp eax,255
   jne key11
   call analizing_picture_to_palette
   mov [register],eax
   call drawwin
   jmp change_screen
 key11:
   cmp eax,27
   jne still
    mov eax,-1
    int 0x40
   jmp still

   change_screen:

   call CalculatePositionScreen
   call MovePictureToWorkScreen
   call draw_scrollers
   call PrintMousePos

   jmp still
;---------------------------------------------
;-----------panel BUTTONS---------------------
;---------------------------------------------
buttons:
	mov eax,17
	int 0x40

	shr eax,8

	cmp eax,1
	jne no_exit
	mov eax,-1
	int 0x40
	no_exit:

	cmp eax,15
	jl no_copy
	pushad
	mov esi,[PointerToPicture]
	mov edi,[PointerToCopyPicture]
	mov ecx,[Picture_SizeX]
	imul ecx,[Picture_SizeY]
	lea ecx,[ecx+ecx*2]
	add ecx,4
	shr ecx,2
	cld
	rep movsd
	popad
	no_copy:

	cmp eax,10
	jl still

	mov [Current_instrument],eax

	cmp eax,15
	je still
	cmp eax,18
	je still
	cmp eax,19
	je still
	cmp eax,21
	jne no_palette_
	call TakeButtonInstruments
	jmp still
	no_palette_:
	cmp eax,23
	je still
	cmp eax,25
	jl TakeButtonInstruments
	cmp eax,29
	ja TakeButtonInstruments
	call TakeButtonInstruments
	jmp still
;---------------------------------------------
;-------------interraction MOUSE--------------
;---------------------------------------------
mouse:

	call GetMouseCoordinats

	;panel
	mov edx,[Window_SizeX]
	sub edx,5

	cmp ebx,20
	jle no_panel
	cmp ebx,20+15
	jae no_panel
	cmp eax,5
	jle no_panel
	cmp eax,edx ;585
	jae no_panel

	call GetMouseCoordinats

	mov [counter],7
	mov edi,panel_text
	call panel_interraction

	jmp still
	no_panel:

	cmp [Panel_flag],0
	jz no_redraw_panel
	mov [counter],7
	mov edi,panel_text
	call panel_interraction
	no_redraw_panel:

	call GetMouseCoordinats
	mov eax,[MouseX]
	mov ebx,[MouseY]
	mov ecx,[WorkScreen_SizeX]
	mov edx,[WorkScreen_SizeY]
	add ecx,9
	add edx,85

	cmp eax,ecx
	jae mouse_scroll

	cmp ebx,edx
	jae mouse_scroll

	jmp no_scrollers

	mouse_scroll:
	;scrollers
	call GetMouseClick
	cmp eax,1
	jne no_click

	call GetMouseCoordinats
	;interraction with horizontal scroller
	mov eax,[Scroll1CoordinatX]
	mov ebx,[Scroll1CoordinatY]
	mov ecx,[MouseX]
	mov edx,[MouseY]
	mov esi,[Scroll1MaxSizeX]
	mov edi,[Scroll1MaxSizeY]
	call columnus
	test eax,eax
	jz no_horizontal


	mov eax,9
	mov ebx,[Scroll1CoordinatY]
	mov ecx,[Scroll1MaxSizeX]
	mov edx,14+10
	mov esi,7
	inc ecx
	call draw_volume_rectangle

	mov eax,[MouseX]
	mov ebx,[Scroll1SizeX]
	shr ebx,1
	sub eax,ebx
	mov ecx,[MouseX]
	add ecx,ebx
	mov edx,8+1
	add edx,[Scroll1MaxSizeX]
	mov [Scroll1CoordinatX],eax

	sub eax,9
	jns no_min_scroll
	mov [Scroll1CoordinatX],9
	no_min_scroll:

	cmp ecx,edx
	jl no_max_scroll
	sub edx,ebx
	sub edx,ebx
	mov [Scroll1CoordinatX],edx
	no_max_scroll:
	;
	mov eax,[Scroll1CoordinatX]
	sub eax,9
	mov ebx,[Picture_SizeX]
	imul eax,ebx
	mov ebx,[Scroll1MaxSizeX]
	cdq
	idiv ebx
	mov [PosX],eax
	jmp no_vertical
	no_horizontal:

	mov eax,[Scroll2CoordinatX]
	mov ebx,[Scroll2CoordinatY]
	mov ecx,[MouseX]
	mov edx,[MouseY]
	mov esi,[Scroll2MaxSizeX]
	mov edi,[Scroll2MaxSizeY]
	call columnus
	test eax,eax
	jz no_vertical

	mov eax,[Scroll2CoordinatX]
	mov ebx,85
	mov ecx,14+10
	mov edx,[Scroll2MaxSizeY]
	mov esi,7
	inc edx
	call draw_volume_rectangle

	mov eax,[MouseY]
	mov ebx,[Scroll2SizeY]
	shr ebx,1
	sub eax,ebx
	mov ecx,[MouseY]
	add ecx,ebx
	mov edx,85
	add edx,[Scroll2MaxSizeY]
	mov [Scroll2CoordinatY],eax

	sub eax,85
	jns no_min_scroll2
	mov [Scroll2CoordinatY],85
	no_min_scroll2:

	cmp ecx,edx
	jl no_max_scroll2
	sub edx,ebx
	sub edx,ebx
	mov [Scroll2CoordinatY],edx
	no_max_scroll2:
	;
	mov eax,[Scroll2CoordinatY]
	sub eax,85
	mov ebx,[Picture_SizeY]
	imul eax,ebx
	mov ebx,[Scroll2MaxSizeY]
	cdq
	idiv ebx
	mov [PosY],eax

	no_vertical:
	call CalculatePositionScreen

	call draw_scrollers
	call MovePictureToWorkScreen
	no_click:
	jmp still
	no_scrollers:

	mov eax,[MouseX]
	mov ebx,[MouseY]
	mov ecx,[Window_SizeX]
	mov edx,[Window_SizeY]
	sub ecx,36
	sub edx,35

	cmp eax,9
	jle still
	cmp eax,ecx
	jae still
	cmp ebx,20+15+1+46
	jle still
	cmp ebx,edx
	jae still


	call GetScreenCordinats
	call PrintMousePos
	call GetMouseClick
	test eax,eax
	jz no_use_instruments
	call TakeButtonInstruments
	no_use_instruments:
	mov [Activate_instrument],0

	jmp still
;-----------------------------------------------
;---------get mouse cordinats-------------------
;-----------------------------------------------
GetMouseCoordinats:

	mov eax,37
	mov ebx,1
	int 0x40

	mov ebx,eax
	shr eax,16
	and ebx,0xffff

	mov [MouseX],eax
	mov [MouseY],ebx

	ret
;------------------------------------------------
;-------get mouse attributs----------------------
;------------------------------------------------
GetMouseClick:
	 mov eax,37
	 mov ebx,2
	 int 0x40

	 ret
;-------------------------------------------------
;-----interraction panel with user----------------
;-------------------------------------------------
panel_interraction:
	;>>>>>>>>>>>>>>>>>>>>>>>>>>
	;mov eax,18
	;mov ebx,14
	;int 0x40

	mov [Panel_flag],0
      next_columnus_text:
	mov eax,[edi]
	mov ebx,[edi+4]
	sub eax,10
	sub ebx,3
	mov [Icon_text_x],eax
	mov [Icon_text_y],ebx
	mov esi,[edi+8]
	add edi,esi
	add edi,3*4
	mov ecx,[MouseX]
	mov edx,[MouseY]
	push edi
	mov edi,13
	mov esi,80
	call columnus

	pop edi
	mov esi,7

	test eax,eax
	jz no_columnus_text

	mov esi,1
	mov [Panel_flag],1
	call GetMouseClick
	test eax,eax
	jz no_mouse_pressed

	call print_panel_menu

	no_mouse_pressed:

	no_columnus_text:

	mov eax,[Icon_text_x]
	mov ebx,[Icon_text_y]
	mov ecx,79
	mov edx,13
	call draw_volume_rectangle

	push [counter]
	push edi
	mov [counter],7
	mov edi,panel_text
	call print_panel_text

	pop edi
	pop [counter]
	dec [counter]
	jnz next_columnus_text

	ret
;---------------------------------------------------------
;-----draw panel menu(main engin of panel)----------------
;---------------------------------------------------------
print_panel_menu:

	push [counter]
	;delit icon buttons(some time)
	mov [counter],10
	next_icon_delit:
	mov eax,8
	mov edx,[counter]
	add edx,11100000000000000000000000000000b
	int 0x40
	inc [counter]
	cmp [counter],30
	jl next_icon_delit

	pop [counter]

	push esi
	mov esi,[counter]
	dec esi
	shl esi,4

	mov eax,[menu_rectangles+esi]
	mov ebx,[menu_rectangles+esi+4]
	mov ecx,[menu_rectangles+esi+8]
	mov edx,[menu_rectangles+esi+12]
	mov esi,1
	mov [menu_coordinat_x],eax
	mov [menu_size_x],ecx
	call draw_volume_rectangle
	pop esi

    calculate_counter_menu:


	;calculate menu counter
	mov eax,[counter]
	dec eax
	shl eax,2
	mov ebx,[menu_counters+eax]
	mov [counter_menu],ebx

	call GetMouseCoordinats

	and [menu_counter],0
	push esi
	push edi
	;ᣫ 樨 >>>>>>>>>>>>>>>>>>
	;mov eax,18
	;mov ebx,14
	;int 0x40

    menu_loop:

	mov eax,[menu_coordinat_x]
	mov ebx,36
	mov ecx,[MouseX]
	mov edx,[MouseY]
	mov esi,[menu_size_x]
	mov edi,18
	add ebx,[menu_counter]
	add eax,2
	sub esi,3
	inc ebx
	call columnus
	mov esi,7

	test eax,eax
	jz no_columnus_menu_text
	mov esi,1
	no_columnus_menu_text:

	mov eax,[menu_coordinat_x]
	mov ebx,36
	mov ecx,[menu_size_x]
	mov edx,18
	add ebx,[menu_counter]
	add eax,2
	sub ecx,3
	inc ebx
	call draw_volume_rectangle
	add [menu_counter],20


	dec [counter_menu]
	jnz menu_loop

	;print menu text
	push [counter]
	mov esi,[counter]
	dec esi
	shl esi,2
	mov edi,[menu_text_en+esi]
	mov eax,[menu_counters+esi]
	mov [counter],eax
	call print_panel_text
	pop [counter]
	pop edi
	pop esi


	menu_still:
	mov eax,10
	int 0x40
	mov eax,2
	int 0x40
	mov eax,17
	int 0x40

	call GetMouseClick
	test eax,eax
	jz calculate_counter_menu

	call GetMouseCoordinats

	;calculate menu counter
	mov eax,[counter]
	dec eax
	shl eax,2
	mov ebx,[menu_counters+eax]
	mov [counter_menu],ebx

	and [menu_counter],0
	and [counter_11],0

	push esi
	push edi

    menu_loop2:


	mov eax,[menu_coordinat_x]
	mov ebx,36
	mov ecx,[MouseX]
	mov edx,[MouseY]
	mov esi,[menu_size_x]
	mov edi,18
	add ebx,[menu_counter]
	add eax,2
	sub esi,3
	inc ebx
	call columnus

	inc [counter_11]

	test eax,eax
	jz no_columnus_menu_text2
	mov esi,[counter_11]
	mov [number_menu],esi
	no_columnus_menu_text2:

	add [menu_counter],20

	dec [counter_menu]
	jnz menu_loop2

	pop edi
	pop esi

	push [counter]
	pushad

	call drawwin

	popad
	pop [counter]

	mov eax,[counter]
	mov [number_panel],eax

	call TakeInstruments
	jmp still

;---------------------------------------------------------
;------print mouse position on panel----------------------
;---------------------------------------------------------
PrintMousePos:

	pushad

	mov eax,385
	mov ebx,20+15+6
	mov ecx,52
	mov edx,18
	mov esi,4
	call draw_volume_rectangle

	mov eax,385
	mov ebx,20+15+6+18+1
	mov ecx,52
	mov edx,18
	mov esi,4
	call draw_volume_rectangle

	mov eax,390
	mov ebx,20+15+6+6
	mov ecx,0
	mov edx,mouse_pos_x
	mov esi,2
	call print_text

	mov eax,390
	mov ebx,20+15+6+6+18+1
	mov ecx,0
	mov edx,mouse_pos_y
	mov esi,2
	call print_text

	mov eax,47
	mov ebx,4*65536
	mov ecx,[ScreenX]
	add ecx,[PosX]
	mov edx,405*65536+20+15+6+6
	mov esi,0
	int 0x40

	mov eax,47
	mov ebx,4*65536
	mov ecx,[ScreenY]
	add ecx,[PosY]
	mov edx,405*65536+20+15+6+18+1+6
	mov esi,0
	int 0x40

	popad
	ret

;---------------------------------------------------------
;---------- get time in 1/100 secunds---------------------
;---------------------------------------------------------
Clock:
	  mov eax,26
	  mov ebx,9
	  int 0x40
	  mov [time],eax
	  ret
;----------------------------------------------------------
;-------------draw window of program-----------------------
;----------------------------------------------------------
drawwin:

	mov eax,12
	mov ebx,1
	int 0x40

	mov eax,0
	mov ebx,[Window_CordinatX]
	mov ecx,[Window_CordinatY]
	shl ebx,16
	shl ecx,16
	add ebx,[Window_SizeX]
	add ecx,[Window_SizeY]
	mov edx,0x03aabbcc
	mov esi,0x805080d0
	mov edi,0x005080d0
	int 0x40

	call draw_panel
	call PrintMousePos

	mov [counter],7
	mov edi,panel_text
	call print_panel_text

	mov eax,10
	mov ebx,5
	mov ecx,0xffffff
	mov edx,name_of_program
	mov esi,34
	call print_text

	mov eax,13
	mov ebx,447*65536+35
	mov ecx,42*65536+36
	mov edx,[Color]
	int 0x40

	;mov eax,100
	;mov ebx,11
	;mov ecx,0xffffff
	;mov edx,file_path
	;mov esi,40
	;call print_text

	;call print_register
	mov eax,12
	mov ebx,2
	int 0x40

	mov eax,9
	mov ebx,IPC_table
	or ecx,-1
	int 0x40

	mov eax,[IPC_table+34]
	mov ebx,[IPC_table+38]
	mov ecx,[IPC_table+42]
	mov edx,[IPC_table+46]
	mov [Window_CordinatX],eax
	mov [Window_CordinatY],ebx
	mov [Window_SizeX],ecx
	mov [Window_SizeY],edx
	mov [MaxWorkScreen_SizeX],ecx
	mov [MaxWorkScreen_SizeY],edx
	sub [MaxWorkScreen_SizeX],20+10+5+10
	sub [MaxWorkScreen_SizeY],20+10+15+1+45+20+10

	mov ecx,[k]

	cmp [MaxWorkScreen_SizeX],0
	jns no_znak1
	mov [MaxWorkScreen_SizeX],ecx
	no_znak1:
	cmp [MaxWorkScreen_SizeY],0
	jns no_znak2
	mov [MaxWorkScreen_SizeY],ecx
	no_znak2:

	cmp [Window_SizeX],585
	ja no_minimum_size_x
	mov [Window_SizeX],585
	no_minimum_size_x:
	cmp [Window_SizeY],130
	ja no_minimum_size_y
	mov [Window_SizeY],130
	no_minimum_size_y:

	and [PosX],0
	and [PosY],0
	call MovePictureToWorkScreen
	call draw_scrollers
	call draw_icons

	ret
;----------------------------------------------------------
;---------------draw panel in window of program------------
;----------------------------------------------------------
draw_panel:

	mov eax,5
	mov ebx,20
	mov ecx,[Window_SizeX]
	mov edx,15
	mov esi,6
	sub ecx,10
	call draw_volume_rectangle

	mov eax,5
	mov ebx,20
	mov ecx,[Window_SizeX]
	mov edx,15
	mov esi,6
	sub ecx,10
	call draw_volume_rectangle

	mov eax,5
	mov ebx,20+15+1
	mov ecx,[Window_SizeX]
	mov edx,46
	mov esi,1
	sub ecx,10
	call draw_volume_rectangle

	mov eax,5
	mov ebx,20+15+1+46+1
	mov ecx,[Window_SizeX]
	mov edx,[Window_SizeY]
	mov esi,1
	sub ecx,10+20
	sub edx,20+15+1+46+1+5+20
	call draw_volume_rectangle

	mov eax,5
	mov ebx,[Window_SizeY]
	mov ecx,[Window_SizeX]
	mov edx,20+10
	mov esi,3
	sub ecx,30
	sub ebx,25+10
	call draw_volume_rectangle

	mov eax,[Window_SizeX]
	mov ebx,20+15+1+45+2
	mov ecx,20+10
	mov edx,[Window_SizeY]
	mov esi,3
	sub eax,25+10
	sub edx,20+15+1+45+5+20
	call draw_volume_rectangle

	mov eax,[Window_SizeX]
	mov ebx,[Window_SizeY]
	mov ecx,20+10
	mov edx,20+10
	mov esi,6
	sub eax,25+10
	sub ebx,25+10
	call draw_volume_rectangle

	mov eax,445
	mov ebx,20+15+6
	mov ecx,37
	mov edx,37
	mov esi,4
	call draw_volume_rectangle

	ret
;----------------------------------------------------------
;---------------------system events------------------------
;----------------------------------------------------------
event:
	mov eax,10
	int 0x40
	ret

;----------------------------------------------------------
;----------print text to the panel and menu----------------
;----------------------------------------------------------
print_panel_text:
       next_panel_text:
	mov eax,[edi]
	mov ebx,[edi+4]
	xor ecx,ecx
	mov edx,edi
	add edx,12
	mov esi,[edi+8]
	add edi,esi
	add edi,3*4
	push edi
	call print_text
	pop edi
	dec [counter]
	jnz next_panel_text
	ret
;----------------------------------------------------------
;--------Move picture from array to work screeen-----------
;----------------------------------------------------------
MovePictureToWorkScreen:

	mov eax,[ScreenPointer]
	mov ebx,[WorkScreen_SizeX]
	imul ebx,[WorkScreen_SizeY]
	lea ebx,[ebx+ebx*2]
	shr ebx,2
	inc ebx
	clear_screen:
	mov [eax],dword 0
	add eax,4
	dec ebx
	jnz clear_screen

	mov eax,[Picture_SizeX]
	mov ebx,[Picture_SizeY]
	mov ecx,[MaxWorkScreen_SizeX]
	mov edx,[MaxWorkScreen_SizeY]
	mov esi,[k]
	imul eax,esi
	imul ebx,esi

	cmp eax,ecx
	jle lab1
	mov eax,[MaxWorkScreen_SizeX]
	mov [WorkScreen_SizeX],eax
	jmp lab2
	lab1:
	mov [WorkScreen_SizeX],eax
	lab2:

	cmp ebx,edx
	jle lab3
	mov ebx,[MaxWorkScreen_SizeY]
	mov [WorkScreen_SizeY],ebx
	jmp lab4
	lab3:
	mov [WorkScreen_SizeY],ebx
	lab4:

	mov eax,[WorkScreen_SizeX]
	mov ebx,[k]
	cdq
	idiv ebx
	mov [CounterX],eax
	mov eax,[WorkScreen_SizeY]
	cdq
	idiv ebx
	mov [CounterY],eax

	mov eax,[WorkScreen_SizeX]
	mov ecx,eax
	mov ebx,[k]
	cdq
	idiv ebx
	imul eax,ebx
	sub ecx,eax
	lea ecx,[ecx+ecx*2]
	;
	mov eax,[WorkScreen_SizeX]
	mov ebx,[k]
	dec ebx
	imul eax,ebx
	lea eax,[eax+eax*2]
	add eax,ecx
	mov [OffsetYWorkScreen],eax;ecx


	mov ebx,[Picture_SizeX]
	mov eax,[CounterX]
	sub ebx,eax
	lea ebx,[ebx+ebx*2]
	mov [OffsetYPicture],ebx

	mov eax,[WorkScreen_SizeX]
	mov ebx,[k]
	sub eax,ebx
	lea eax,[eax+eax*2]
	mov [OffsetYBigPixel],eax

	mov eax,[PosX]
	mov ebx,[PosY]
	mov ecx,[Picture_SizeX]
	imul ecx,ebx
	add eax,ecx
	lea eax,[eax+eax*2]
	add eax,[PointerToPicture]


	mov ebx,[ScreenPointer]

	mov edi,[CounterY]

	screen_y:
	    mov esi,[CounterX]
	    screen_x:
	      mov ecx,[eax]
	      and ecx,0xffffff
	      mov ebp,ecx
	      shr ecx,16
	      push ebx
	      push eax
	      mov edx,[k]
	      big_pixel_y:
		 mov eax,[k]
		 big_pixel_x:
		   mov [ebx],bp
		   mov [ebx+2],cl
		   add ebx,3
		 dec eax
		 jnz big_pixel_x
		 add ebx,[OffsetYBigPixel]
	      dec edx
	      jnz big_pixel_y
	      pop eax
	      pop ebx
	      mov edx,[k]
	      lea edx,[edx+edx*2]
	      add ebx,edx
	      add eax,3
	    dec esi
	    jnz screen_x
	    add eax,[OffsetYPicture]
	    add ebx,[OffsetYWorkScreen]
	dec edi
	jnz screen_y

	 ;mov eax,18
	 ;mov ebx,14
	 ;int 0x40

	 mov eax,7
	 mov ebx,[ScreenPointer]
	 mov ecx,[WorkScreen_SizeX]
	 mov edx,[WorkScreen_SizeY]
	 shl ecx,16
	 add ecx,edx
	 mov edx,8*65536+20+15+45+5
	 int 0x40

	ret
;----------------------------------------------------------
;------------draw lines of scoll---------------------------
;----------------------------------------------------------
draw_scrollers:
	 mov edi,[CounterX]
	 mov eax,[Scroll1CoordinatX]
	 mov ebx,[Window_SizeY]
	 sub ebx,22+10
	 mov ecx,[Window_SizeX]
	 sub ecx,10+5+20+10+1
	 mov edx,14+10
	 mov esi,1
	 mov [Scroll1CoordinatX],eax
	 mov [Scroll1CoordinatY],ebx
	 mov [Scroll1MaxSizeY],edx
	 mov [Scroll1MaxSizeX],ecx
	 imul ecx,edi
	 push eax
	 push ebx
	 push edx
	 mov eax,ecx
	 mov ebx,[Picture_SizeX]
	 cdq
	 idiv ebx
	 mov ecx,eax
	 pop edx
	 pop ebx
	 pop eax
	 mov [Scroll1SizeX],ecx
	 mov edi,[Scroll1MaxSizeX]
	 sub edi,ecx
	 mov [Scroll1FreeX],edi
	 call draw_volume_rectangle

	 mov eax,[Window_SizeX]
	 sub eax,22+10
	 mov ebx,[Scroll2CoordinatY]
	 mov ecx,14+10
	 mov edx,[Window_SizeY]
	 sub edx,20+15+1+46+10+20+11
	 mov esi,1
	 mov [Scroll2CoordinatX],eax
	 mov [Scroll2CoordinatY],ebx
	 mov [Scroll2MaxSizeX],ecx
	 mov [Scroll2MaxSizeY],edx

	 imul edx,[CounterY]
	 push eax
	 push ebx
	 mov eax,edx
	 mov ebx,[Picture_SizeY]
	 cdq
	 idiv ebx
	 mov edx,eax
	 pop ebx
	 pop eax
	 mov [Scroll2SizeY],edx
	 mov edi,[Scroll2MaxSizeY]
	 sub edi,edx
	 mov [Scroll2FreeY],edi

	 call draw_volume_rectangle

	 ret
;----------------------------------------------------------
;--------change size of memory which use program-----------
;----------------------------------------------------------
GetMemory:
	 pushad
	 mov eax,64
	 mov ebx,1
	 mov ecx,[Picture_SizeX]
	 mov edx,[Picture_SizeY]
	 imul ecx,edx
	 lea ecx,[ecx+ecx*2]
	 shl ecx,1
	 add ecx,0x19000+(1200*1000)*3+30*(20*20*3)+100000+16000+0x4000
	 add ecx,[extended_memory]
	 int 0x40
	 test eax,eax
	 jz have_new_memory
	 mov esi,sound_havent_memory
	 call sound
	 jmp still
	 have_new_memory:
	 popad
	 ret
;-----------------------------------------------------------
;-----------instruments of menu-----------------------------
;-----------------------------------------------------------
TakeInstruments:

	 ;|||||||||||||||||||FILE||||||||||||||||||||||
	 cmp [number_panel],7
	 jne no_file

	 ;<<<<<NEW>>>>>>>
	 cmp [number_menu],1
	 jne no_new
	 mov eax,80
	 mov ebx,100
	 mov ecx,150
	 mov edx,90
	 mov  esi,1
	 call draw_volume_rectangle
	 mov eax,177
	 mov ebx,115
	 mov ecx,40
	 mov edx,14
	 mov  esi,4
	 call draw_volume_rectangle
	 mov eax,177
	 mov ebx,115+24
	 mov ecx,40
	 mov edx,14
	 mov  esi,4
	 call draw_volume_rectangle
	 mov eax,175
	 mov ebx,170
	 mov ecx,40
	 mov edx,15
	 mov  esi,1
	 call draw_volume_rectangle
	 mov eax,90
	 mov ebx,118
	 mov ecx,0xffffff
	 mov edx,new_text1
	 mov esi,14
	 call print_text
	 mov eax,90
	 mov ebx,118+24
	 mov ecx,0xffffff
	 mov edx,new_text2
	 mov esi,14
	 call print_text
	 mov eax,185
	 mov ebx,175
	 mov ecx,0xffffff
	 mov edx,ok_text
	 mov esi,2
	 call print_text
	 mov eax,8
	 mov ebx,177*65536+40
	 mov ecx,115*65536+14
	 mov edx,1000000000000000000000000000000b
	 add edx,1000
	 int 0x40
	 mov eax,8
	 mov ebx,177*65536+40
	 mov ecx,139*65536+14
	 mov edx,1000000000000000000000000000000b
	 add edx,1001
	 int 0x40
	 mov eax,8
	 mov ebx,175*65536+40
	 mov ecx,170*65536+15
	 mov edx,1000000000000000000000000000000b
	 add edx,1002
	 int 0x40

	 no_activate_space:
	 mov eax,10
	 int 0x40
	 cmp eax,1
	 je exit_new
	 cmp eax,3
	 jne no_activate_space
	 mov eax,17
	 int 0x40
	 shr eax,8
	 cmp eax,1000
	 jl no_activate_space

	 cmp eax,1000
	 jne no_picture_size_x
	 mov eax,180
	 mov ebx,119
	 mov ecx,5
	 call dialog_line
	 mov eax,string_
	 mov ebx,13
	 call find_symvol
	 dec eax
	 mov [length_number],eax
	 mov eax,string_
	 call value
	 mov [Picture_SizeX],eax
	 jmp no_activate_space
	 no_picture_size_x:

	 cmp eax,1001
	 jne no_picture_size_y
	 mov eax,180
	 mov ebx,119+24
	 mov ecx,5
	 call dialog_line
	 mov eax,string_
	 mov ebx,13
	 call find_symvol
	 dec eax
	 mov [length_number],eax
	 mov eax,string_
	 call value
	 mov [Picture_SizeY],eax
	 jmp no_activate_space
	 no_picture_size_y:

	 cmp eax,1002
	 jne no_activate_space

	 exit_new:

	 mov eax,8
	 mov ebx,175*65536+40
	 mov ecx,170*65536+15
	 mov edx,11100000000000000000000000000000b
	 add edx,1002
	 int 0x40
	 mov eax,8
	 mov ebx,177*65536+40
	 mov ecx,139*65536+14
	 mov edx,11100000000000000000000000000000b
	 add edx,1001
	 int 0x40
	 mov eax,8
	 mov ebx,177*65536+40
	 mov ecx,115*65536+14
	 mov edx,11100000000000000000000000000000b
	 add edx,1000
	 int 0x40

	 and [extended_memory],0
	 call GetMemory
	 and [number_panel],0
	 and [number_menu],0

	 mov eax,[PointerToPicture]
	 mov ebx,[Picture_SizeX]
	 imul ebx,[Picture_SizeY]
	 lea ebx,[ebx+ebx*2]
	 mov [PointerToCopyPicture],ebx
	 add [PointerToCopyPicture],0x19000+(1200*1000*3)+30*(20*20*3)+100000
	 shr ebx,2
	 inc ebx
	 clear_new_screen:
	 mov [eax],dword 0xffffff
	 mov [eax+3],byte 0xff
	 add eax,4
	 dec ebx
	 jnz clear_new_screen
	 and [save_flag],0
	 call drawwin
	 jmp still
	 no_new:

	 ;<<<<<OPEN>>>>>>>
	 cmp [number_menu],2
	 jne no_open
	 opendialog drawwin,open_1,open_1,file_path
	 open_1:

	 mov eax,40
	 mov ebx,100111b
	 int 0x40
	 mov [file_info],dword 0
	 mov [file_info+8],dword 1
	 mov [file_info+12],dword 0x19000+0x10000
	 mov eax,58
	 mov ebx,file_info
	 int 0x40
	 mov [length_file],ebx
	 mov [delete_bug],0

	 and [extended_memory],0
	 mov eax,((1200*1000*3)-65536-(30*20*20*3+100000))
	 mov ebx,eax
	 sub eax,[length_file]
	 jns no_new_memory
	 mov eax,[length_file]
	 sub eax,ebx
	 mov [extended_memory],eax
	 mov [delete_bug],1
	 call GetMemory
	 no_new_memory:
	 call load_file

	 mov esi,0x19000+0x10000
	 mov ax,[esi]
	 mov [type],ax
	 cmp [type],word 'BM'
	 jne no_bmp_file
	 mov eax,[esi+18]
	 mov ebx,[esi+22]
	 mov [Picture_SizeX],eax
	 mov [Picture_SizeY],ebx
	 imul eax,ebx
	 lea eax,[eax+eax*2]
	 mov ebx,[extended_memory]
	 add eax,ebx
	 mov [PointerToCopyPicture],eax
	 mov [PointerToPicture],ebx
	 add [PointerToPicture],0x19000+(1200*1000*3)+30*(20*20*3)+100000
	 add [PointerToCopyPicture],0x19000+(1200*1000*3)+30*(20*20*3)+100000
	 call GetMemory
	 mov ebx,[PointerToPicture]
	 cmp [delete_bug],0
	 jz no_bug
	 sub ebx,4
	 no_bug:
	 bmptoimg 0x19000+0x10000,0
	 mov [Scroll1CoordinatX],9
	 mov [Scroll2CoordinatY],85
	 call load_icons
	 call drawwin
	 and [number_panel],0
	 and [number_menu],0
	 mov [save_flag],1
	 jmp still
	 no_bmp_file:

	 mov esi,0x19000+0x10000
	 xor eax,eax
	 mov ax,[esi]
	 mov [type],ax
	 cmp [type],'GI'
	 jne no_gif_file
	 mov esi,0x19000+0x10000+6
	 xor eax,eax
	 xor ebx,ebx
	 mov ax,word[esi]
	 mov bx,word[esi+2]
	 mov [Picture_SizeX],eax
	 mov [Picture_SizeY],ebx
	 imul eax,ebx
	 lea eax,[eax+eax*2]
	 mov ebx,[extended_memory]
	 add eax,ebx
	 mov [PointerToCopyPicture],eax
	 mov [PointerToPicture],ebx
	 add [PointerToPicture],0x19000+(1200*1000*3)+30*(20*20*3)+100000
	 add [PointerToCopyPicture],0x19000+(1200*1000*3)+30*(20*20*3)+100000
	 call GetMemory
	 mov esi,0x19000+0x10000
	 mov edi,[PointerToPicture]
	 sub edi,12
	 mov eax,0x19000
	 call ReadGIF
	 mov [Scroll1CoordinatX],9
	 mov [Scroll2CoordinatY],85
	 call load_icons
	 call drawwin
	 and [number_panel],0
	 and [number_menu],0
	 mov [save_flag],1
	 no_gif_file:
	 open_2:
	 jmp still
	 no_open:

	 ;<<<<<<<<<<<SAVE>>>>>>>>>>>>
	 cmp [number_menu],3
	 jne no_save_
	 mov al,[save_flag]
	 test al,al
	 jz no_save_file

	 jmp save_enter

	 no_save_file:
	 and [number_panel],0
	 and [number_menu],0
	 jmp still
	 no_save_:

	 ;<<<<<<<<<SAVE AS>>>>>>>>>>>
	 cmp [number_menu],4
	 jne no_save
	 savedialog drawwin,open1,open2,file_path
	 open1:

	 save_enter:
	 mov eax,40
	 mov ebx,100111b
	 int 0x40

	 call analizing_picture_to_palette
	 ;eax => number of colors in picture
	 mov ebx,[PointerToPicture]
	 mov ecx,[PointerToCopyPicture]
	 mov edx,[PointerToPalette]
	 mov esi,[Picture_SizeX]
	 mov edi,[Picture_SizeY]
	 call coding_bmp

	 mov [file_info],dword 1
	 mov [file_info+8],dword ebx
	 mov [file_info+12],edi

	 mov eax,58
	 mov ebx,file_info
	 int 0x40

	 mov [save_flag],1
	 and [number_panel],0
	 and [number_menu],0
	 call drawwin

	 jmp still
	 open2:
	 and [number_panel],0
	 and [number_menu],0

	 jmp still
	 no_save:

	 ;<<<<<<EXIT>>>>>>>
	 cmp [number_menu],5
	 jne no_exit_program
	 mov eax,-1
	 int 0x40
	 no_exit_program:

	 no_file:
	 ;|||||||||||||||||||||||||||||EDIT|||||||||||||||||||||||||

	 ;<<<<<<<<<<UNDO>>>>>>>>>>
	 cmp [number_panel],6
	 jne no_edit
	 cmp [number_menu],1
	 jne no_undo
	 mov edi,[PointerToPicture]
	 mov esi,[PointerToCopyPicture]
	 mov ecx,[Picture_SizeX]
	 imul ecx,[Picture_SizeY]
	 lea ecx,[ecx+ecx*2]
	 add ecx,4
	 shr ecx,2
	 cld
	 rep movsd
	 call MovePictureToWorkScreen
	 and [number_panel],0
	 and [number_menu],0
	 jmp still
	 no_undo:

	 and [number_panel],0
	 and [number_menu],0
	 jmp still
	 no_edit:

	 jmp still

	 ret
;-----------------------------------------------------------
;-----instruments of panel(icon's instruments)--------------
;-----------------------------------------------------------
TakeButtonInstruments:

	mov eax,[Current_instrument]

	;*************************brush 1***********************
	cmp eax,10
	jne no_brush1
	mov [Brush_SizeX],4
	mov [Brush_SizeY],4
	mov [Number_Brush],0
	and [Current_instrument],0
	jmp still
	no_brush1:

	;*************************brush 2***********************
	cmp eax,11
	jne no_brush2
	mov [Brush_SizeX],6
	mov [Brush_SizeY],4
	mov [Number_Brush],1
	and [Current_instrument],0
	jmp still
	no_brush2:

	;*************************brush 3***********************
	cmp eax,12
	jne no_brush3
	mov [Brush_SizeX],8
	mov [Brush_SizeY],7
	mov [Number_Brush],2
	and [Current_instrument],0
	jmp still
	no_brush3:

	;************************brush 4************************
	cmp eax,13
	jne no_brush4
	mov [Brush_SizeX],14
	mov [Brush_SizeY],14
	mov [Number_Brush],3
	and [Current_instrument],0
	jmp still
	no_brush4:

	;************************brush 5************************
	cmp eax,14
	jne no_brush5
	mov [Brush_SizeX],6
	mov [Brush_SizeY],6
	mov [Number_Brush],4
	and [Current_instrument],0
	jmp still
	no_brush5:

	;*************************pensil************************
	cmp eax,15
	jne no_pensil
	mov eax,[ScreenY]
	mov ebx,[Picture_SizeX]
	add eax,[PosY]
	imul eax,ebx
	add eax,[ScreenX]
	add eax,[PosX]
	lea eax,[eax+eax*2]
	add eax,[PointerToPicture]
	mov ebx,[Color]
	mov [eax],bx
	shr ebx,16
	mov [eax+2],bl
	call MovePictureToWorkScreen
	jmp still
	no_pensil:

	;**********************pipetka**************************
	cmp eax,16
	jne no_pipetka
	mov eax,[ScreenY]
	mov ebx,[Picture_SizeX]
	add eax,[PosY]
	imul eax,ebx
	add eax,[ScreenX]
	add eax,[PosX]
	lea eax,[eax+eax*2]
	add eax,[PointerToPicture]
	mov ebx,[eax]
	and ebx,0xffffff
	mov [Color],ebx
	mov eax,13
	mov ebx,447*65536+35
	mov ecx,42*65536+36
	mov edx,[Color]
	int 0x40
	jmp still
	no_pipetka:

	;**********************draw brush***********************
	cmp eax,18
	jne no_brush
	mov eax,[Color]
	mov [SColor],eax

	lastik_in:

	mov eax,[ScreenX]
	mov ebx,[ScreenY]
	mov ecx,[Brush_SizeX]
	mov edx,[Brush_SizeY]
	add eax,[PosX]
	add ebx,[PosY]
	add eax,ecx
	add ebx,edx

	cmp eax,[Picture_SizeX]
	jl no_max_pos_x
	mov eax,[Picture_SizeX]
	no_max_pos_x:

	cmp ebx,[Picture_SizeY]
	jl no_max_pos_y
	mov ebx,[Picture_SizeY]
	no_max_pos_y:

	cmp eax,ecx
	ja no_min_pos_x
	mov eax,[Brush_SizeX]
	no_min_pos_x:

	cmp ebx,edx
	ja no_min_pos_y
	mov ebx,[Brush_SizeY]
	no_min_pos_y:

	sub eax,[Brush_SizeX]
	sub ebx,[Brush_SizeY]
	mov edi,[Number_Brush]
	imul edi,20*20

	mov [x],eax
	mov [y],ebx
	mov ebp,[Picture_SizeX]
	xor edx,edx
	brush_y:
	  xor ecx,ecx
	  brush_x:
	   ;calculate position in array of brush
	   mov esi,edx
	   lea esi,[esi+esi*4] ;esi=esi*5
	   shl esi,2	       ;esi=(esi*3)*4
	   add esi,ecx
	   add esi,edi
	   ;read byte from array
	   xor eax,eax
	   mov al,[Brush_color+esi]
	   test eax,eax
	   jz no_color_
	   mov eax,[x]
	   mov ebx,[y]
	   add eax,ecx
	   add ebx,edx
	   imul ebx,ebp; ebp=[Picture_SizeX]
	   add eax,ebx
	   lea eax,[eax+eax*2]
	   add eax,[PointerToPicture]
	   mov ebx,[SColor]
	   mov [eax],bx
	   shr ebx,16
	   mov [eax+2],bl
	   no_color_:
	   inc ecx
	   cmp ecx,20;[Brush_SizeX]
	  jl brush_x
	inc edx
	cmp edx,20;[Brush_SizeY]
	jl brush_y

	call MovePictureToWorkScreen
	jmp still
	no_brush:

	;************************lastik*************************
	cmp eax,19
	jne no_lastik
	mov [SColor],0xffffff
	jmp lastik_in
	no_lastik:

	;***********************palette*************************
	cmp eax,21
	jne no_palette

	mov eax,20
	mov ebx,100
	mov ecx,32*10+32*5+7
	mov edx,8*10+7*10
	mov  esi,1
	call draw_volume_rectangle
	mov [x],20+5
	mov [y],100+10
	mov edi,256
	xor esi,esi
	next_rectangle:
	mov eax,13
	mov ebx,[x]
	mov ecx,[y]
	mov edx,[palitra+esi]
	and edx,0xffffff
	shl ebx,16
	shl ecx,16
	add ebx,13
	add ecx,13
	int 0x40
	add [x],15
	cmp [x],20+15*32
	jl no_new_line
	mov [x],20+5
	add [y],15
	no_new_line:
	add esi,4
	dec edi
	jnz next_rectangle
	wait_events:
	call event
	cmp eax,1
	je still
	cmp eax,2
	jne no_keys
	mov eax,2
	int 0x40
	no_keys:
	cmp eax,3
	jne no_buttons
	mov eax,17
	int 0x40
	no_buttons:
	cmp eax,6
	jne wait_events
	call GetMouseClick
	test eax,eax
	jz wait_events
	call GetMouseCoordinats
	mov [x],20+5
	mov [y],100+10
	mov [counter],0
	next_rectangle_column:
	mov eax,[x]
	mov ebx,[y]
	mov ecx,[MouseX]
	mov edx,[MouseY]
	mov esi,13
	mov edi,13
	call columnus
	test eax,eax
	jz no_columnus_color
	mov eax,[counter]
	shl eax,2
	mov ebx,[palitra+eax]
	and ebx,0xffffff
	mov [Color],ebx
	no_columnus_color:
	add [x],15
	cmp [x],20+15*32
	jl no_new_line_column
	mov [x],20+5
	add [y],15
	no_new_line_column:
	inc [counter]
	cmp [counter],257
	jne next_rectangle_column
	mov eax,5
	mov ebx,10
	int 0x40
	call drawwin
	and [Current_instrument],0
	jmp still
	no_palette:

	;************************draw line**********************
	cmp eax,22
	jne no_line
	jmp no_line
	;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<Unfinished function of menu>>>>>>>>>>>>>>>>>>
	mov al,[Activate_instrument]
	test al,al
	jnz no_new_line_xy
	mov eax,[ScreenX]
	mov ebx,[ScreenY]
	add eax,[PosX]
	add ebx,[PosY]
	mov [OldX],eax
	mov [OldY],ebx
	mov [Activate_instrument],1
	mov eax,[ReserveArray]
	mov ecx,24999
	clear_array1:
	mov [eax],dword 0
	add eax,4
	dec ecx
	jnz clear_array1
	jmp still
	no_new_line_xy:

	mov eax,[PointerToPicture]
	mov ebx,[ReserveArray]
	add ebx,4
	mov ecx,[Picture_SizeX]
	mov edx,[OldX]
	shl edx,16
	add edx,[OldY]
	mov esi,[ScreenX]
	mov edi,[ScreenY]
	add esi,[PosX]
	add edi,[PosY]

	call calculate_line
	mov ebx,[ReserveArray]
	mov [ebx],eax

	mov ecx,eax
	mov edx,[Color]
	mov esi,[Color]
	shr edx,16
	add ebx,4
	next_pixel_put:
	mov eax,[ebx]
	mov [eax],si
	mov [eax+2],dl
	add ebx,4
	dec ecx
	jnz next_pixel_put
	;mov ebx,[ReserveArray]
	;mov eax,[ebx]
	;test eax,eax
	;jz no_put_pixels
	;jmp no_put_pixels
	;mov esi,eax
	;mov edx,esi
	;inc edx
	;shl edx,2
	;add edx,[ReserveArray]
	;
	;mov ebp,esi
	;xor esi,esi
	;next_pixel_put_line:
	;mov eax,[ReserveArray+esi+4]
	;mov ecx,[eax]
	;mov [edx],ecx       ;save screen pixels in array
	;add esi,4
	;add edx,4
	;dec ebp
	;jnz next_pixel_put_line
	;no_put_pixels:

	;mov edi,0
	;next_line_:
	;mov esi,[ebx]
	;mov edx,esi
	;inc edx
	;shl edx,2
	;add edx,[ReserveArray]

	;mov ebp,esi
	;xor esi,esi
	;next_pixel_copy_line:
	;mov eax,[ReserveArray+esi+4]
	;mov ecx,[eax]
	;mov [edx],ecx       ;save screen pixels in array
	;mov ecx,[Color]
	;mov [eax],cx        ;draw pixels on screen
	;shr ecx,16
	;mov [eax+2],cl
	;add esi,4
	;add edx,4
	;dec ebp
	;jnz next_pixel_copy_line

	;inc edi
	;cmp edi,1
	;jne next_line_

	call MovePictureToWorkScreen
	jmp still
	no_line:

	;*********************************DRAW RECTANGLE****************************
	cmp eax,23
	jne no_rectangle
	jmp no_rectangle
	;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<Unfinished function of menu>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	mov al,[Activate_instrument]
	test al,al
	jnz no_new_rectangle_xy
	mov eax,[ScreenX]
	mov ebx,[ScreenY]
	add eax,[PosX]
	add ebx,[PosY]
	mov [OldX],eax
	mov [OldY],ebx
	mov [Activate_instrument],1
	mov eax,[ReserveArray]
	clear_array2:
	mov [eax],dword 0
	add eax,4
	dec ecx
	jnz clear_array2

	;ret
	jmp still
	no_new_rectangle_xy:

	mov eax,[PointerToPicture]
	mov ebx,[ReserveArray]
	add ebx,4
	mov ecx,[Picture_SizeX]
	mov edx,[OldX]
	shl edx,16
	add edx,[OldY]
	mov esi,[ScreenX]
	mov edi,[ScreenY]
	add esi,[PosX]
	add edi,[PosY]

	call calculate_rectangle

	mov ebx,[ReserveArray]
	mov [ebx],eax

	mov ecx,eax
	mov edx,[Color]
	mov esi,[Color]
	shr edx,16
	add ebx,4
	next_pixel_put_rectangle:
	mov eax,[ebx]
	mov [eax],si
	mov [eax+2],dl
	add ebx,4
	dec ecx
	jnz next_pixel_put_rectangle

	call MovePictureToWorkScreen
	jmp still
	no_rectangle:

	;*********************************DRAW CIRCLE****************************
	cmp eax,24
	jne no_circle
	jmp no_circle
	;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<Unfinished function of menu>>>>>>>>>>>>>>>>>>>>>>
	mov al,[Activate_instrument]
	test al,al
	jnz no_new_circle_xy
	mov eax,[ScreenX]
	mov ebx,[ScreenY]
	add eax,[PosX]
	add ebx,[PosY]
	mov [OldX],eax
	mov [OldY],ebx
	mov [Activate_instrument],1
	mov eax,[ReserveArray]
	clear_array3:
	mov [eax],dword 0
	add eax,4
	dec ecx
	jnz clear_array3

	;ret
	jmp still
	no_new_circle_xy:

	mov esi,[ScreenX]
	mov edi,[ScreenY]
	mov edx,[OldX]
	mov ebp,[OldY]
	add esi,[PosX]
	add edi,[PosY]
	shr esi,1
	shr edi,1
	shr edx,1
	shr ebp,1
	add esi,edx
	add edi,ebp
	mov [x],esi
	mov [y],edi
	sub esi,[OldX]
	sub edi,[OldY]
	inc esi
	inc edi
	mov [Dx_],esi
	mov [Dy_],edi

	;finit
	fild [Dx_]
	fmul st,st
	fild [Dy_]
	fmul st,st
	fadd st,st1
	fsqrt
	fistp [Radius]
	fistp [Icon_X]

	mov [Type_phigure],4
	mov [Length_array],4

	next_circle:

	mov eax,[PointerToPicture]
	mov ebx,[ReserveArray]
	add ebx,[Length_array]
	mov ecx,[Picture_SizeX]
	mov edx,[x]
	shl edx,16
	add edx,[y]
	mov esi,[Radius]
	call calculate_circle

	mov ebx,[ReserveArray]
	add ebx,[Length_array]
	sub ebx,4
	mov [ebx],eax
	add [Length_array],eax
	add [Length_array],eax
	add [Length_array],eax
	add [Length_array],eax
	add [Length_array],4

	add [Radius],1
	sub [Type_phigure],1
	jns next_circle

	mov [Type_phigure],4
	mov ebx,[ReserveArray]
	next_circle_draw:
	mov eax,[ebx]
	mov ecx,eax
	mov edx,[Color]
	mov esi,[Color]
	shr edx,16
	add ebx,4
	next_pixel_put_circle:
	mov eax,[ebx]
	mov [eax],si
	mov [eax+2],dl
	add ebx,4
	dec ecx
	jnz next_pixel_put_circle
	dec [Type_phigure]
	jns next_circle_draw

	call MovePictureToWorkScreen
	jmp still
	no_circle:

	;************************zoom 1*************************
	cmp eax,25
	jne no_1_
	mov [k],1
	mov [Scroll1CoordinatX],9
	mov [Scroll2CoordinatY],85
	and [Current_instrument],0
	call drawwin
	jmp still
	no_1_:

	;*************************zoom 2************************
	cmp eax,26
	jne no_2_
	mov [k],2
	call drawwin
	mov [Scroll1CoordinatX],9
	mov [Scroll2CoordinatY],85
	and [Current_instrument],0
	jmp still
	no_2_:

	;*************************zoom 4************************
	cmp eax,27
	jne no_4_
	mov [k],4
	call drawwin
	mov [Scroll1CoordinatX],9
	mov [Scroll2CoordinatY],85
	and [Current_instrument],0
	jmp still
	no_4_:

	;************************zoom 8*************************
	cmp eax,28
	jne no_8_
	mov [k],8
	call drawwin
	mov [Scroll1CoordinatX],9
	mov [Scroll2CoordinatY],85
	and [Current_instrument],0
	jmp still
	no_8_:

	;************************zoom 16************************
	cmp eax,29
	jne no_16_
	mov [k],16
	call drawwin
	mov [Scroll1CoordinatX],9
	mov [Scroll2CoordinatY],85
	and [Current_instrument],0
	jmp still
	no_16_:

	ret
;-----------------------------------------------------------
;-----------calculat cordinats on work picture--------------
;-----------------------------------------------------------
GetScreenCordinats:

	mov eax,[MouseX]
	mov ebx,[MouseY]
	sub eax,9
	sub ebx,85

	mov ecx,[k]
	cdq
	idiv ecx
	mov [ScreenX],eax
	mov eax,ebx
	cdq
	idiv ecx
	mov [ScreenY],eax

	ret
;-----------------------------------------------------------
;-------find simvole in string------------------------------
;-----------------------------------------------------------
find_symvol:
	;eax,string
	;ebx,symvol
	mov esi,eax
	next_symvol:
	xor ecx,ecx
	mov cl,[eax]
	cmp cl,bl
	je symvol_fined
	inc eax
	jmp next_symvol

	symvol_fined:
	sub eax,esi
	ret
;-----------------------------------------------------------
;--------load file in memory--------------------------------
;-----------------------------------------------------------
load_file:
	 mov eax,58
	 mov ebx,file_info
	 int 0x40
	 test eax,eax
	 jnz no_open_
	 mov [length_file],ebx
	 shr ebx,9
	 inc ebx
	 mov [file_info+8],ebx
	 mov eax,58
	 mov ebx,file_info
	 int 0x40
	 no_open_:
	 ret
;-----------------------------------------------------------
;---load icons  in memory and draw icons on panel-----------
;-----------------------------------------------------------
load_icons:
	 mov esi,panel_picture
	 mov edi,0x19000+(1200*1000*3)
	 mov eax,0x19000
	 call ReadGIF

	 ret
draw_icons:
	 mov [Icon_X],10
	 mov [Icon_Y],20+15+4
	 and [counter],0
   next_icon:
	 mov eax,8
	 mov ebx,[Icon_X]
	 mov ecx,[Icon_Y]
	 dec ebx
	 dec ecx
	 shl ebx,16
	 shl ecx,16
	 add ebx,20
	 add ecx,20
	 mov edx,[counter]
	 add edx,10
	 add edx,1000000000000000000000000000000b
	 int 0x40


	 mov edx,[Icon_X]
	 shl edx,16
	 add edx,[Icon_Y]
	 mov ebx,[counter]
	 imul ebx,20*20*3
	 add ebx,0x19000+(1200*1000*3)+12
	 mov eax,7
	 mov ecx,20*65536+20
	 int 0x40

	 add [Icon_X],25
	 cmp [Icon_X],10+25*15
	 jl no_next_line_icons
	 mov [Icon_X],10
	 mov [Icon_Y],20+15+4+22
	 no_next_line_icons:
	 inc [counter]
	 cmp [counter],30
	 jl next_icon

	 ret
;-----------------------------------------------------------
;calculat position work screen on a picture
;-----------------------------------------------------------
CalculatePositionScreen:

	 mov eax,[Picture_SizeX]
	 mov ebx,[Picture_SizeY]
	 mov ecx,[CounterX]
	 mov edx,[CounterY]
	 sub eax,ecx
	 sub ebx,edx

	 cmp [PosX],eax
	 jle no_limit_screen_x
	 mov [PosX],eax
	 no_limit_screen_x:

	 cmp [PosY],ebx
	 jle no_limit_screen_y
	 mov [PosY],ebx
	 no_limit_screen_y:

	 cmp [PosX],0
	 jns no_minimum_screen_x
	 mov [PosX],0
	 no_minimum_screen_x:

	 cmp [PosY],0
	 jns no_minimum_screen_y
	 mov [PosY],0
	 no_minimum_screen_y:

	 ret
;-----------------------------------------------------------
;-------analizing picture to palette------------------------
;-----------------------------------------------------------
analizing_picture_to_palette:

	 mov eax,[Picture_SizeX]
	 mov ebx,[Picture_SizeY]
	 imul eax,ebx
	 mov ecx,eax
	 mov edx,[PointerToPicture]
	 mov esi,1 ;counter colors in palette

	 ;put firs color of picture how one color in palette
	 mov ebp,[PointerToPalette]
	 mov eax,[edx]
	 and eax,0xffffff
	 mov [ebp],eax

	 analizing_to_palette:
	 mov eax,[edx]
	 and eax,0xffffff

	 mov edi,esi
	 mov ebp,[PointerToPalette]
	 next_color_in_palette:
	 mov ebx,[ebp]
	 and ebx,0xffffff
	 cmp ebx,eax	     ;this is color have in palette
	 je exit_loop_palette
	 add ebp,4
	 dec edi
	 jnz next_color_in_palette

	 inc esi
	 cmp esi,256 ;256 colors
	 ja more_than_256_colors
	 mov ebp,[PointerToPalette]
	 mov ebx,esi
	 dec ebx
	 shl ebx,2
	 add ebp,ebx
	 mov [ebp],ax
	 shr eax,16
	 mov [ebp+2],al

	 exit_loop_palette:

	 add edx,3
	 dec ecx
	 jnz analizing_to_palette


	 more_than_256_colors:
	 mov eax,esi
	 ret
;---------------------------------------------------------
;---------------SOUND of EVENTS---------------------------
;---------------------------------------------------------
sound:
	  mov eax,55
	  mov ebx,eax
	  int 0x40
	  ret
;---------------------------------------------------------
;----------------------------------
print_register:
	  pushad
	  mov eax,13
	  mov ebx,30*65536+50
	  mov ecx,12*65536+11
	  mov edx,0xffffff
	  int 0x40
	  mov eax,47
	  mov ebx,12*65536
	  mov ecx,[register]
	  mov edx,5*65536+12
	  mov esi,0x0;ffffff
	  int 0x40
	  popad
	  mov eax,5
	  mov ebx,3
	  int 0x40
	  ret
;----------------------------------------------------------
;-------------file info sctruche---------------------------
;----------------------------------------------------------
file_info:
		     dd 0
		     dd 0
		     dd 1
		     dd 0x19000+0x10000
		     dd 0x19000

		    file_path:
		     times 256 db 0
;-----------------------------------------------------------
;------------variables and data of program------------------
;-----------------------------------------------------------
length_file	     dd 0

time		     dd 0
sound_havent_memory  db 150,64,0
PosX		     dd 0
PosY		     dd 0
ScreenPointer	     dd 0
PointerToPicture     dd 0
PointerToCopyPicture dd 0
PointerToPalette     dd 0
Color		     dd 0
Number_Brush	     dd 0
Brush_SizeX	     dd 0
Brush_SizeY	     dd 0
Current_instrument   dd 0
Activate_instrument  db 0
SColor		     dd 0
OldX		     dd 0
OldY		     dd 0
ReserveArrayPos      dd 0

MouseX		     dd 0
MouseY		     dd 0
Window_SizeX	     dd 0
Window_SizeY	     dd 0
Window_CordinatX     dd 0
Window_CordinatY     dd 0
Picture_SizeX	     dd 0
Picture_SizeY	     dd 0
ScreenX 	     dd 0
ScreenY 	     dd 0
WorkScreen_SizeX     dd 0
WorkScreen_SizeY     dd 0
MaxWorkScreen_SizeX  dd 0
MaxWorkScreen_SizeY  dd 0
k		     dd 0
IPC_table	     rd 256
ReserveArray	     dd 0
register	     dd 0
CounterX	     dd 0
CounterY	     dd 0
OffsetYPicture	     dd 0
OffsetYWorkScreen    dd 0
OffsetYBigPixel      dd 0

Icon_X		     dd 0
Icon_Y		     dd 0
counter 	     dd 0
counter2	     dd 0
Icon_text_x	     dd 0
Icon_text_y	     dd 0
Panel_flag	     db 0
counter_menu	     dd 0
menu_coordinat_x     dd 0
menu_size_x	     dd 0
menu_counter	     dd 0
counter_11	     dd 0
number_panel	     dd 0
number_menu	     dd 0

Scroll1CoordinatX    dd 0
Scroll1CoordinatY    dd 0
Scroll1MaxSizeX      dd 0
Scroll1MaxSizeY      dd 0
Scroll1SizeX	     dd 0
Scroll1FreeX	     dd 0

Scroll2CoordinatX    dd 0
Scroll2CoordinatY    dd 0
Scroll2MaxSizeX      dd 0
Scroll2MaxSizeY      dd 0
Scroll2SizeY	     dd 0
Scroll2FreeY	     dd 0

extended_memory      dd 0
type		     dw 0
delete_bug	     db 0
x		     dd 0
y		     dd 0
save_flag	     db 0

Radius		     dd 0
Dx_		     dd 0
Dy_		     dd 0
Type_phigure	     dd 0
Length_array	     dd 0
;**********************************************************
;------------------TEXT DATA-------------------------------
;**********************************************************
name_of_program      db 'Graphics edit <<<ANIMAGE>>> V1.00 '
mouse_pos_x	     db 'X='
mouse_pos_y	     db 'Y='
new_text1	     db 'PICTURE SIZE X'
new_text2	     db 'PICTURE SIZE Y'
ok_text 	     db 'OK'

panel_text	     dd 15,24,4
		     db 'FILE'
		     dd 95,24,4
		     db 'EDIT'
		     dd 175,24,11
		     db 'INSTRUMENTS'
		     dd 255,24,7
		     db 'PALETTE'
		     dd 335,24,7
		     db 'FILTERS'
		     dd 415,24,9
		     db 'ANIMATION'
		     dd 495,24,4
		     db 'HELP'
menu_text_en:
		     dd menu_text7
		     dd menu_text6
		     dd menu_text5
		     dd menu_text4
		     dd menu_text3
		     dd menu_text2
		     dd menu_text1
		     dd 0,0,0

menu_rectangles      dd 485,36,100,100
		     dd 405,36,100,100
		     dd 325,36,100,100
		     dd 245,36,100,100
		     dd 165,36,100,100
		     dd 85,36,100,100
		     dd 5,36,100,100


menu_text1:
		     dd 15,45,3
		     db 'NEW'
		     dd 15,65,4
		     db 'OPEN'
		     dd 15,85,4
		     db 'SAVE'
		     dd 15,105,7
		     db 'SAVE AS'
		     dd 15,125,4
		     db 'EXIT'

menu_text2:
		     dd 95,45,4
		     db 'UNDO'
		     dd 95,65,4
		     db 'COPY'
		     dd 95,85,5
		     db 'PASTE'
		     dd 95,105,3
		     db 'CUT'
		     dd 95,125,4
		     db 'SIZE'
menu_text3:
		     dd 175,45,6
		     db 'PENCIL'
		     dd 175,65,7
		     db 'BRUSHES'
		     dd 175,85,6
		     db 'COLORS'
		     dd 175,105,7
		     db 'PIPETKA'
menu_text4:
		     dd 255,45,1
		     db 0,0,0
menu_text5:
		     dd 335,45,1
		     db 0,0,0
menu_text6:
		     dd 415,45,1
		     db 0,0,0
menu_text7:
		     dd 495,45,1
		     db 0,0,0,0


menu_counters:
		     dd 1,1,1,1,5,4,5

;----------------------------------------------------------
palitra:		 ;three bytes for one color
db 0,0,0,0,0,0,128,0
db 0,128,0,0,0,128,128,0
db 128,0,0,0,128,0,128,0
db 128,128,0,0,128,128,128,0
db 192,220,192,0,240,202,166,0
db 170,63,42,0,255,63,42,0
db 0,95,42,0,85,95,42,0
db 170,95,42,0,255,95,42,0
db 0,127,42,0,85,127,42,0
db 170,127,42,0,255,127,42,0
db 0,159,42,0,85,159,42,0
db 170,159,42,0,255,159,42,0
db 0,191,42,0,85,191,42,0
db 170,191,42,0,255,191,42,0
db 0,223,42,0,85,223,42,0
db 170,223,42,0,255,223,42,0
db 0,255,42,0,85,255,42,0
db 170,255,42,0,255,255,42,0
db 0,0,85,0,85,0,85,0
db 170,0,85,0,255,0,85,0
db 0,31,85,0,85,31,85,0
db 170,31,85,0,255,31,85,0
db 0,63,85,0,85,63,85,0
db 170,63,85,0,255,63,85,0
db 0,95,85,0,85,95,85,0
db 170,95,85,0,255,95,85,0
db 0,127,85,0,85,127,85,0
db 170,127,85,0,255,127,85,0
db 0,159,85,0,85,159,85,0
db 170,159,85,0,255,159,85,0
db 0,191,85,0,85,191,85,0
db 170,191,85,0,255,191,85,0
db 0,223,85,0,85,223,85,0
db 170,223,85,0,255,223,85,0
db 0,255,85,0,85,255,85,0
db 170,255,85,0,255,255,85,0
db 0,0,127,0,85,0,127,0
db 170,0,127,0,255,0,127,0
db 0,31,127,0,85,31,127,0
db 170,31,127,0,255,31,127,0
db 0,63,127,0,85,63,127,0
db 170,63,127,0,255,63,127,0
db 0,95,127,0,85,95,127,0
db 170,95,127,0,255,95,127,0
db 0,127,127,0,85,127,127,0
db 170,127,127,0,255,127,127,0
db 0,159,127,0,85,159,127,0
db 170,159,127,0,255,159,127,0
db 0,191,127,0,85,191,127,0
db 170,191,127,0,255,191,127,0
db 0,223,127,0,85,223,127,0
db 170,223,127,0,255,223,127,0
db 0,255,127,0,85,255,127,0
db 170,255,127,0,255,255,127,0
db 0,0,170,0,85,0,170,0
db 170,0,170,0,255,0,170,0
db 0,31,170,0,85,31,170,0
db 170,31,170,0,255,31,170,0
db 0,63,170,0,85,63,170,0
db 170,63,170,0,255,63,170,0
db 0,95,170,0,85,95,170,0
db 170,95,170,0,255,95,170,0
db 0,127,170,0,85,127,170,0
db 170,127,170,0,255,127,170,0
db 0,159,170,0,85,159,170,0
db 170,159,170,0,255,159,170,0
db 0,191,170,0,85,191,170,0
db 170,191,170,0,255,191,170,0
db 0,223,170,0,85,223,170,0
db 170,223,170,0,255,223,170,0
db 0,255,170,0,85,255,170,0
db 170,255,170,0,255,255,170,0
db 0,0,212,0,85,0,212,0
db 170,0,212,0,255,0,212,0
db 0,31,212,0,85,31,212,0
db 170,31,212,0,255,31,212,0
db 0,63,212,0,85,63,212,0
db 170,63,212,0,255,63,212,0
db 0,95,212,0,85,95,212,0
db 170,95,212,0,255,95,212,0
db 0,127,212,0,85,127,212,0
db 170,127,212,0,255,127,212,0
db 0,159,212,0,85,159,212,0
db 170,159,212,0,255,159,212,0
db 0,191,212,0,85,191,212,0
db 170,191,212,0,255,191,212,0
db 0,223,212,0,85,223,212,0
db 170,223,212,0,255,223,212,0
db 0,255,212,0,85,255,212,0
db 170,255,212,0,255,255,212,0
db 85,0,255,0,170,0,255,0
db 0,31,255,0,85,31,255,0
db 170,31,255,0,255,31,255,0
db 0,63,255,0,85,63,255,0
db 170,63,255,0,255,63,255,0
db 0,95,255,0,85,95,255,0
db 170,95,255,0,255,95,255,0
db 0,127,255,0,85,127,255,0
db 170,127,255,0,255,127,255,0
db 0,159,255,0,85,159,255,0
db 170,159,255,0,255,159,255,0
db 0,191,255,0,85,191,255,0
db 170,191,255,0,255,191,255,0
db 0,223,255,0,85,223,255,0
db 170,223,255,0,255,223,255,0
db 85,255,255,0,170,255,255,0
db 255,204,204,0,255,204,255,0
db 255,255,51,0,255,255,102,0
db 255,255,153,0,255,255,204,0
db 0,127,0,0,85,127,0,0
db 170,127,0,0,255,127,0,0
db 0,159,0,0,85,159,0,0
db 170,159,0,0,255,159,0,0
db 0,191,0,0,85,191,0,0
db 170,191,0,0,255,191,0,0
db 0,223,0,0,85,223,0,0
db 170,223,0,0,255,223,0,0
db 85,255,0,0,170,255,0,0
db 0,0,42,0,85,0,42,0
db 170,0,42,0,255,0,42,0
db 0,31,42,0,85,31,42,0
db 170,31,42,0,255,31,42,0
db 0,63,42,0,170,174,160,0
db 240,251,255,0,164,160,160,0
db 128,128,128,0,0,0,255,0
db 0,255,0,0,0,255,255,0
db 255,0,0,0,255,0,255,0
db 255,255,0,0xff,0xff,0xff,0xff
;----------------------------------------------------------
;--------------------COLOR BRUSHES-------------------------
;----------------------------------------------------------
Brush_color:
;
db 0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;
db 0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;
db 0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0
db 1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0
db 1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0
db 1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0
db 0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;
db 0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0
db 0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0
db 0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0
db 0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0
db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0
db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0
db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0
db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0
db 0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0
db 0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0
db 0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0
db 0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;
db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;
db 0
;----------------------------------------------------------
;-------------------ICON"S picture-------------------------
;----------------------------------------------------------
panel_picture:
file 'worktab1.gif'

;file '/hd/1/pk/animage/worktab1.gif'

;----------------------------------------------------------

I_END:


